local MinBuild, MaxBuild, Build = 40000, 0, select(4, GetBuildInfo())
if Build < MinBuild or ( MaxBuild > 0 and Build > MaxBuild ) then return end
local AddonName, a = ...
local AddonTitle = select(2, GetAddOnInfo(AddonName))
local PlainAddonTitle = AddonTitle:gsub("|c........", ""):gsub("|r", "")
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables

local c = BittensSpellFlashLibrary2

------------------------------------------------------------------------- Common
a.spells["Combat Mind LFR"] = { ID = 109793 }
a.spells["Combat Mind"] = { ID = 107970 }
a.spells["Combat Mind Heroic"] = { ID = 109795 }
a.spells["Stolen Time"] = { ID = 105785 }

a.spells["Evocation"] = {
    ID = 12051,
}

a.spells["Flame Orb"] = {
    ID = 82731,
    NoRangeCheck = 1,
    FlashColor = "yellow",
}

a.spells["Conjure Mana Gem"] = {
    ID = 759,
    FlashColor = "yellow",
    CheckFirst = function()
        local count = GetItemCount("Mana Gem", false, true)
        if s.InCombat() then
            return count == 0
        else
            return count < 3
        end
    end    
}

a.spells["Mana Gem"] = {
    Type = "item",
    ID = 36799,
    FlashColor = "yellow",
}

a.spells["Molten Armor"] = {
    ID = 30482,
    FlashColor = "yellow",
    CheckFirst = function()
        return c.SelfBuffNeeded("Molten Armor")
    end
}

a.spells["Mirror Images"] = {
    ID = 55342,
    FlashColor = "yellow",
}

a.spells["Arcane Brilliance"] = {
    ID = 1459,
    NoRangeCheck = 1,
    FlashColor = "yellow",
    CheckFirst = function()
        return c.RaidBuffNeeded(c.INTELLECT_BUFFS)
    end
}

a.spells["Dalaran Brilliance"] = {
    ID = 61316,
    NoRangeCheck = 1,
    FlashColor = "yellow",
    CheckFirst = function()
        return c.RaidBuffNeeded(c.INTELLECT_BUFFS)
    end
}

------------------------------------------------------------------------- Arcane
a.spells["Arcane Power"] = {
    ID = 12042,
    NonGCD = true,
    FlashColor = "yellow",
}

a.spells["Arcane Blast"] = {
    ID = 30451,
}

a.spells["Arcane Missiles"] = {
    ID = 5143,
}

a.spells["Arcane Barrage"] = {
    ID = 44425,
}

a.spells["Presence of Mind"] = {
    ID = 12043,
    FlashColor = "yellow",
    NoGCD = true,
}

a.spells["Mage Armor"] = {
    ID = 6117,
    FlashColor = "yellow",
    CheckFirst = function()
        return c.SelfBuffNeeded("Mage Armor")
    end
}

-------------------------------------------------------------------------- Frost
a.spells["Brain Freeze"] = { ID = 57761 }
a.spells["Fingers of Frost"] = { ID = 44544 }

a.spells["Frostbolt"] = {
    ID = 116,
}

a.spells["Deep Freeze"] = {
    ID = 44572,
}

a.spells["Instant Frozen Frostfire Bolt"] = {
    ID = 44614,
--    Run = function(z)
--        z.RequireBuff = { c.GetID("Brain Freeze"), c.GetID("Fingers of Frost") }
--        z.RequireBuffUnit = "player"
--    end
    CheckFirst = function()
        return c.HasBuff("Brain Freeze")
            and c.HasBuff("Fingers of Frost")
    end
}

a.spells["Frozen Ice Lance"] = {
    ID = 30455,
    Run = function(z)
        z.RequireBuff = c.GetID("Fingers of Frost")
        z.RequireBuffUnit = "player"
        z.ConsumeBuff = c.GetID("Fingers of Frost")
        z.ConsumeBuffUnit = "player"
    end
--    CheckFirst = function()
--        return c.HasBuff("Fingers of Frost")
--    end
}

a.spells["Freeze"] = {
    ID = 2027,
}

a.spells["Frostfire Orb"] = {
    ID = 82731, -- flame orb
    FlashID = { 82731, 92283 }, 
    NoRangeCheck = 1,
}

a.spells["Icy Viens"] = {
    ID = 12472,
}

a.spells["Cold Snap"] = {
    ID = 11958,
}

a.spells["Summon Water Elemental"] = {
    ID = 31687,
    FlashColor = "yellow",
    CheckFirst = function()
        return not x.PetAlive
    end
}

a.spells["Freeze"] = {
    ID = 33395,
    Continue = 1,
    FlashColor = "yellow",
    NoRangeCheck = 1,
    CheckFirst = function()
        local dfcd = c.GetCooldown("Deep Freeze")
        return (dfcd == 0 or dfcd > 25)
            and not c.HasBuff("Fingers of Frost")
            and c.GetCooldown("Frostfire Orb") < 45
    end
}